% tree_sum(+Tree, ?Sum): The sum of the leaves of Tree is Sum.
tree_sum(Tree, Value) :- Tree = leaf(Value).
tree_sum(node(Left, Right), S) :-
	tree_sum(Left, S1),
	tree_sum(Right, S2),
	S is S1+S2.

% tree(+Tree): Tree is a binary tree of integers.
% The Prolog representation of the following Mercury type definition:
% :- type tree ---> leaf(int) | node(tree, tree).
tree(leaf(Value)) :-
	integer(Value).
tree(node(Left, Right)) :-
	tree(Left),
	tree(Right).


end_of_file.

| ?- tree_sum(node(leaf(5),
                   node(leaf(3),
		        leaf(2))), S).
S = 10 ? ;
no
| ?-


