% tree_sum(+Tree, ?Sum): The sum of the leaves of Tree is Sum.
tree_sum(leaf(Value), Value).
tree_sum(node(Left, Right), S) :-
    plus(S1, S2, S),
	tree_sum(Left, S1),
	tree_sum(Right, S2).

% plus(X, Y, Z): X+Y = Z.
% (Where all numbers are positive, and Z =< 4.)
plus(1, 1, 2).
plus(1, 2, 3).
plus(1, 3, 4).
plus(2, 1, 3).
plus(2, 2, 4).
plus(3, 1, 4).

end_of_file.

| ?- tree_sum(T, 3).
T = leaf(3) ? ;
T = node(leaf(1),leaf(2)) ? ;
T = node(leaf(1),node(leaf(1),leaf(1))) ? ;
T = node(leaf(2),leaf(1)) ? ;
T = node(node(leaf(1),leaf(1)),leaf(1)) ? ;
no
| ?- trace.
% The debugger will first creep -- showing everything (trace)
yes
% trace
| ?- tree_sum(T, 3).
        1      1 Call: tree_sum(_508,3) ? 
?       1      1 Exit: tree_sum(leaf(3),3) ? 
T = leaf(3) ? ;
        1      1 Redo: tree_sum(leaf(3),3) ? 
        2      2 Call: plus(_1158,_1159,3) ? 
?       2      2 Exit: plus(1,2,3) ? 
        3      2 Call: tree_sum(_1155,1) ? 
?       3      2 Exit: tree_sum(leaf(1),1) ? 
        4      2 Call: tree_sum(_1156,2) ? s
?       4      2 Exit: tree_sum(leaf(2),2) ? 
?       1      1 Exit: tree_sum(node(leaf(1),leaf(2)),3) ? 
T = node(leaf(1),leaf(2)) ? ;
        1      1 Redo: tree_sum(node(leaf(1),leaf(2)),3) ? s
?       1      1 Exit: tree_sum(node(leaf(1),node(leaf(1),leaf(1))),3) ? 
T = node(leaf(1),node(leaf(1),leaf(1))) ? ;
        1      1 Redo: tree_sum(node(leaf(1),node(leaf(1),leaf(1))),3) ? 
        4      2 Redo: tree_sum(node(leaf(1),leaf(1)),2) ? s
        4      2 Fail: tree_sum(_1156,2) ? 
        3      2 Redo: tree_sum(leaf(1),1) ? 
        5      3 Call: plus(_2585,_2586,1) ? 
        5      3 Fail: plus(_2585,_2586,1) ? 
        3      2 Fail: tree_sum(_1155,1) ? 
        2      2 Redo: plus(1,2,3) ? 
?       2      2 Exit: plus(2,1,3) ? o
?       1      1 Exit: tree_sum(node(leaf(2),leaf(1)),3) ? 
T = node(leaf(2),leaf(1)) ? ;
        1      1 Redo: tree_sum(node(leaf(2),leaf(1)),3) ? s
?       1      1 Exit: tree_sum(node(node(leaf(1),leaf(1)),leaf(1)),3) ? 
T = node(node(leaf(1),leaf(1)),leaf(1)) ? ;
        1      1 Redo: tree_sum(node(node(leaf(1),leaf(1)),leaf(1)),3) ? 
        6      2 Call: plus(_2198,_2199,1) ? 
        6      2 Fail: plus(_2198,_2199,1) ? 
        7      2 Call: plus(_2181,_2182,1) ? 
        7      2 Fail: plus(_2181,_2182,1) ? 
        8      2 Call: plus(_2164,_2165,1) ? 
        8      2 Fail: plus(_2164,_2165,1) ? 
        2      2 Redo: plus(2,1,3) ? 
        2      2 Fail: plus(_1158,_1159,3) ? 
        1      1 Fail: tree_sum(_508,3) ? 
no
% trace
| ?- tree_sum(node(leaf(2),leaf(1)), S).
        1      1 Call: tree_sum(node(leaf(2),leaf(1)),_583) ? 
        2      2 Call: plus(_1253,_1254,_583) ? 
?       2      2 Exit: plus(1,1,2) ? 
        3      2 Call: tree_sum(leaf(2),1) ? 
        3      2 Fail: tree_sum(leaf(2),1) ? 
        2      2 Redo: plus(1,1,2) ? 
?       2      2 Exit: plus(1,2,3) ? 
        4      2 Call: tree_sum(leaf(2),1) ? 
        4      2 Fail: tree_sum(leaf(2),1) ? 
        2      2 Redo: plus(1,2,3) ? 
?       2      2 Exit: plus(1,3,4) ? 
        5      2 Call: tree_sum(leaf(2),1) ? 
        5      2 Fail: tree_sum(leaf(2),1) ? 
        2      2 Redo: plus(1,3,4) ? 
?       2      2 Exit: plus(2,1,3) ? 
        6      2 Call: tree_sum(leaf(2),2) ? 
        6      2 Exit: tree_sum(leaf(2),2) ? 
        7      2 Call: tree_sum(leaf(1),1) ? 
        7      2 Exit: tree_sum(leaf(1),1) ? 
?       1      1 Exit: tree_sum(node(leaf(2),leaf(1)),3) ? 
S = 3 ? ;
        1      1 Redo: tree_sum(node(leaf(2),leaf(1)),3) ? 
        2      2 Redo: plus(2,1,3) ? 
?       2      2 Exit: plus(2,2,4) ? 
        8      2 Call: tree_sum(leaf(2),2) ? 
        8      2 Exit: tree_sum(leaf(2),2) ? 
        9      2 Call: tree_sum(leaf(1),2) ? 
        9      2 Fail: tree_sum(leaf(1),2) ? 
        2      2 Redo: plus(2,2,4) ? 
        2      2 Exit: plus(3,1,4) ? 
       10      2 Call: tree_sum(leaf(2),3) ? 
       10      2 Fail: tree_sum(leaf(2),3) ? 
        1      1 Fail: tree_sum(node(leaf(2),leaf(1)),_583) ? 
no
% trace
| ?- 
