% deriv(Expr, D):  D is the derivative of Expr with respect to x.
% Expr is a term built from numbers and the atom x using the arithmetic
% operators +, -, and *.

deriv(x, 1).
deriv(C, 0) :-
	number(C).
deriv(U+V, DU+DV) :-
	deriv(U, DU), deriv(V, DV).
deriv(U-V, DU-DV) :-
	deriv(U, DU), deriv(V, DV).
deriv(U*V, DU*V + U*DV) :-
	deriv(U, DU), deriv(V, DV).

end_of_file.

| ?- deriv(x*x+x, D).
D = 1*x+x*1+1 ? ;
no
| ?- deriv((x+1)*(x+1), D).
D = (1+0)*(x+1)+(x+1)*(1+0) ? ;
no
| ?- deriv(I, 1*x+x*1+1).
I = x*x+x ? ;
no
| ?- deriv(I, 0).
no
| ?- 
