% Since it is not possible to redefine a built-in predicate, we use
% the name app, instead of append.


% app(L1, L2, L3): 
% The concatenation of L1 and L2 is L3.
app([], L, L).              % The concatenation of [] and L is L.
app([X|L1], L2, [X|L3]) :-  % The concatenation of [X|L1] and L2 is [X|L3] if
        app(L1, L2, L3).    %           the concatenation of L1 and L2 is L3.

	
end_of_file.


| ?- app([1,2], [3,4], L).
L = [1,2,3,4] ? ;
no
| ?- app(L1, L2, [1,2,3,4]).
L1 = [],
L2 = [1,2,3,4] ? ;
L1 = [1],
L2 = [2,3,4] ? ;
L1 = [1,2],
L2 = [3,4] ? ;
L1 = [1,2,3],
L2 = [4] ? ;
L1 = [1,2,3,4],
L2 = [] ? ;
no
| ?- trace, app([1,2], [3,4], L).
% The debugger will first creep -- showing everything (trace)
        1      1 Call: app([1,2],[3,4],_576) ? 
        2      2 Call: app([2],[3,4],_1249) ? g
Ancestors:
        1      1 Call: app([1,2],[3,4],[1|_1249])
        2      2 Call: app([2],[3,4],_1249) ? 
        3      3 Call: app([],[3,4],_2203) ? g
Ancestors:
        1      1 Call: app([1,2],[3,4],[1,2|_2203])
        2      2 Call: app([2],[3,4],[2|_2203])
        3      3 Call: app([],[3,4],_2203) ? 
        3      3 Exit: app([],[3,4],[3,4]) ? g
Ancestors:
        1      1 Call: app([1,2],[3,4],[1,2,3,4])
        2      2 Call: app([2],[3,4],[2,3,4])
        3      3 Exit: app([],[3,4],[3,4]) ? 
        2      2 Exit: app([2],[3,4],[2,3,4]) ? 
        1      1 Exit: app([1,2],[3,4],[1,2,3,4]) ? 
L = [1,2,3,4] ? ;
no
% trace
| ?- app(L1, L2, [1,2,3,4]).
        1      1 Call: app(_522,_544,[1,2,3,4]) ? 
?       1      1 Exit: app([],[1,2,3,4],[1,2,3,4]) ? 
L1 = [],
L2 = [1,2,3,4] ? ;
        1      1 Redo: app([],[1,2,3,4],[1,2,3,4]) ? 
        2      2 Call: app(_1321,_544,[2,3,4]) ? g
Ancestors:
        1      1 Call: app([1|_1321],_544,[1,2,3,4])
        2      2 Call: app(_1321,_544,[2,3,4]) ? 
?       2      2 Exit: app([],[2,3,4],[2,3,4]) ? 
?       1      1 Exit: app([1],[2,3,4],[1,2,3,4]) ? 
L1 = [1],
L2 = [2,3,4] ? ;
        1      1 Redo: app([1],[2,3,4],[1,2,3,4]) ? 
        2      2 Redo: app([],[2,3,4],[2,3,4]) ? 
        3      3 Call: app(_2275,_544,[3,4]) ? g
Ancestors:
        1      1 Call: app([1,2|_2275],_544,[1,2,3,4])
        2      2 Call: app([2|_2275],_544,[2,3,4])
        3      3 Call: app(_2275,_544,[3,4]) ? 
?       3      3 Exit: app([],[3,4],[3,4]) ? 
?       2      2 Exit: app([2],[3,4],[2,3,4]) ? 
?       1      1 Exit: app([1,2],[3,4],[1,2,3,4]) ? 
L1 = [1,2],
L2 = [3,4] ? ;
        1      1 Redo: app([1,2],[3,4],[1,2,3,4]) ? 
        2      2 Redo: app([2],[3,4],[2,3,4]) ? 
        3      3 Redo: app([],[3,4],[3,4]) ? 
        4      4 Call: app(_3243,_544,[4]) ? g
Ancestors:
        1      1 Call: app([1,2,3|_3243],_544,[1,2,3,4])
        2      2 Call: app([2,3|_3243],_544,[2,3,4])
        3      3 Call: app([3|_3243],_544,[3,4])
        4      4 Call: app(_3243,_544,[4]) ? 
?       4      4 Exit: app([],[4],[4]) ? 
?       3      3 Exit: app([3],[4],[3,4]) ? 
?       2      2 Exit: app([2,3],[4],[2,3,4]) ? 
?       1      1 Exit: app([1,2,3],[4],[1,2,3,4]) ? 
L1 = [1,2,3],
L2 = [4] ? ;
        1      1 Redo: app([1,2,3],[4],[1,2,3,4]) ? 
        2      2 Redo: app([2,3],[4],[2,3,4]) ? 
        3      3 Redo: app([3],[4],[3,4]) ? 
        4      4 Redo: app([],[4],[4]) ? 
        5      5 Call: app(_4225,_544,[]) ? g
Ancestors:
        1      1 Call: app([1,2,3,4|_4225],_544,[1,2,3,4])
        2      2 Call: app([2,3,4|_4225],_544,[2,3,4])
        3      3 Call: app([3,4|_4225],_544,[3,4])
        4      4 Call: app([4|_4225],_544,[4])
        5      5 Call: app(_4225,_544,[]) ? 
?       5      5 Exit: app([],[],[]) ? 
?       4      4 Exit: app([4],[],[4]) ? 
?       3      3 Exit: app([3,4],[],[3,4]) ? 
?       2      2 Exit: app([2,3,4],[],[2,3,4]) ? 
?       1      1 Exit: app([1,2,3,4],[],[1,2,3,4]) ? 
L1 = [1,2,3,4],
L2 = [] ? ;
        1      1 Redo: app([1,2,3,4],[],[1,2,3,4]) ? 
        2      2 Redo: app([2,3,4],[],[2,3,4]) ? 
        3      3 Redo: app([3,4],[],[3,4]) ? 
        4      4 Redo: app([4],[],[4]) ? 
        5      5 Redo: app([],[],[]) ? 
        5      5 Fail: app(_4225,_544,[]) ? 
        4      4 Fail: app(_3243,_544,[4]) ? 
        3      3 Fail: app(_2275,_544,[3,4]) ? 
        2      2 Fail: app(_1321,_544,[2,3,4]) ? 
        1      1 Fail: app(_522,_544,[1,2,3,4]) ? 
no
% trace
| ?- 
