% Since it is not possible to redefine a built-in predicate, we use
% the name memb, instead of member.

% member(E, L): E is an element of list L.
memb(Elem, [Elem|_]).              % The list head is an element.
memb(Elem, [_|Tail]) :-            % The elements of the tail
        memb(Elem, Tail).          % are elements of the list.


% An alternative formulation, using disjunction (to be discussed later)	
% memb2(E, L): E is an element of list L.
memb2(Elem, [Head|Tail]) :-        % Elem is an element of list [Head|Tail] if
        (   Elem = Head            % either it is equal to Head
        ;   memb2(Elem, Tail)      % or it is an element of Tail.
        ).





