% nrev(L, R): List R contains the elements of L in reverse order - 
% a naive solution.
nrev([], []).
nrev([X|L], R) :-
    nrev(L, RL),
    append(RL, [X], R).

% reverse(L, R): List R contains the elements of L in reverse order -
% an efficient solution.
reverse(L, R) :-
	revapp(L, [], R).

% revapp(L1, L2, R): The reverse of L1 prepended to L2 gives L3.
revapp([], R, R).
revapp([X|L1], L2, R) :-
    revapp(L1, [X|L2], R).
