% fact0(+N, ?F): F = N!.   
fact0(0, 1).
fact0(N, F) :-
    N > 0,
    N1 is N-1, fact0(N1, F1),
    F is N*F1.

% fact1(+N, ?F): F = N!.   
fact1(0, F) :- !, F = 1.                    
fact1(N, F) :-                  
	N > 0,
	N1 is N-1,           
	fact1(N1, F1),
	F is N*F1.

% fact2(N, F): F = N!.
fact2(N, F) :-
    (   N = 0 -> F = 1                              
    ;   N > 0, N1 is N-1,
        fact2(N1, F1),
        F is N*F1 
    ).      

% Tail recursive variant:

% fact(N, F): F = N!.	       
fact(N, F) :-     
    fact(N, 1, F).

% fact(N, F0, F): F = F0*N!.                                 
fact(N, F0, F) :-                                            
    (   N =:= 0 -> F = F0                                     
    ;   N > 0,
        F1 is F0*N,
        N1 is N-1,
        fact(N1, F1, F)
    ).                                                

