% sum0(+L, ?Sum): Sum is the sum of the elements in number list L.
% Not tail recursive.
sum0([], 0).
sum0([X|L], Sum) :-
	sum0(L, Sum0),
	Sum is Sum0+X.

% sum(+L, +Sum0, -Sum): Sum is Sum0 + (the sum of list L)
%                       i.e. (the sum of list L) = Sum - Sum0.
% Tail recursive.
sum([], Sum, Sum).
sum([X|L], Sum0, Sum) :-
        Sum1 is Sum0+X,
        sum(L, Sum1, Sum).

% sum(+List, -Sum): the sum of the elements of List is Sum.
% Available as sumlist/2 in library(lists)
sum(List, Sum) :-
	sum(List, 0, Sum).
