:- use_module(library(lists), [scanlist/4]).

% When using SWI, remove the above line and uncomment the line below:

% scanlist(Pred, L, A0, A) :- foldl(Pred, L, A0, A).

% revapp0(L, R0, R): The reverse of L prepended to  R0 gives R.
revapp0([], R0, R) :- 
    R = R0.
revapp0([X|L], R0, R) :-
    R1 = [X|R0],
    revapp0(L, R1, R).

% revapp1(L, R0, R): The reverse of L prepended to  R0 gives R.
revapp1([], R0, R) :- 
    R = R0.
revapp1([X|L], R0, R) :-
    cons(X, R0, R1),
    revapp1(L, R1, R).

cons(X, L0, L1) :-
    L1 = [X|L0].

% revapp2(L, R0, R): The reverse of L prepended to  R0 gives R.
revapp2(L, R0, R) :-
    scanlist(cons, L, R0, R).

% S0+X = S1. 
plus(X, S0, S1) :-
    S1 is S0+X.

% L sums to Sum
sum2(L, Sum) :-
    scanlist(plus, L, 0, Sum).

% decomp(X, L0, L1): List L0 can be decomposed to head X and tail L1
decomp(X, L0, L1) :-
    L0 = [X|L1].

% decomp is the inverse of cons:
% | ?- cons(X, A, B), decomp(Y, B, C).
%                                       Y = X, C = A, B = [X|A] ? 

% L1 appended with L2 gives L.
app(L1, L2, L) :-
    scanlist(decomp, L1, L, L2).
