% tree_list0(+Tree, ?List): The list of the leaf values of Tree is List.
tree_list0(leaf(Value), [Value]).
tree_list0(node(Left, Right), L) :-
        tree_list0(Left, L1),
	tree_list0(Right, L2),
	append(L1, L2, L).


% tree_list(+Tree, +L0, L): The list of the    
% leaf values of Tree prepended to L0 is L.    
tree_list(leaf(Value), L0, L) :-               
        L = [Value|L0].
tree_list(node(Left, Right), L0, L) :-
        tree_list(Right, L0, L1),
        tree_list(Left, L1, L).

% The list of the leaf values of Tree is L.
tree_list(Tree, L) :-                      
       tree_list(Tree, [], L).             

end_of_file.

| ?- tree_list0(node(node(leaf(1),leaf(2)), leaf(4)), L).
L = [1,2,4] ? ;
no
| ?- tree_list(node(node(leaf(1),leaf(2)), leaf(4)), L).
L = [1,2,4] ? ;
no
| ?- 
