% value_of(+Poly, +X, ?V): V is the value of the formula Poly, for x=X
% Poly is built from the atom x and numbers using binary operators allowed in is/2.
value_of(x, X, V) :-
        V = X.
value_of(N, _, V) :-                
        number(N), V = N.
value_of(Poly, X, V) :-        		       
        Poly =.. [Func,P1,P2],
        value_of(P1, X, V1),                   
        value_of(P2, X, V2),                   
        PolyV =.. [Func,V1,V2],
        V is PolyV.          

end_of_file.

| ?- value_of0((x+1)*x+x+2*(x+x+3), 2, V).
V = 22 ? ;
no
| ?- value_of((x+1)*x+x+2*(x+x+3), 2, V).
V = 22 ? ;
no
| ?- value_of(exp(100,min(x,1/x)), 2, V).
V = 10.0 ? ;
no
| ?- value_of0(exp(100,min(x,1/x)), 2, V).
no
| ?- 
