% This file shows how to implement univ, given functor and arg, 
% and vice versa.
% In case of error, the behaviour of the my_... predicates may be
% different from that of the corresponding BIPs

% my_univ(Term, List): Term =.. List.
my_univ(Term, [Name|Args]) :-
	(   var(Term) -> length(Args, Arity)
	;   true
	),
	functor(Term, Name, Arity),
	args_between(1, Arity, Term, Args).

% args_between(N, M, Term, Args): Args is a list of arguments
% N, N+1, ... M of term Term.
args_between(N, Max, Term, Args) :-
	(   N > Max -> Args = []
	;   Args = [Arg|Args1],
	    arg(N, Term, Arg),
	    N1 is N+1,
	    args_between(N1, Max, Term, Args1)
	).

% my_functor(Term, Name, Arity): functor(Term, Name, Arity)
my_functor(Term, Name, Arity) :-
	var(Term), !,
	length(Args, Arity),
	Term =.. [Name|Args].
my_functor(Term, Name, Arity) :-
	Term =.. [Name|Args],
	length(Args, Arity).

:- use_module(library(lists), [nth1/3]).

% my_arg(N, Term, Arg): arg(N, Term, Arg).
my_arg(N, Term, Arg) :-
	Term =.. [_|Args],
	nth1(N, Args, Arg).
