:- use_module(library(between), [between/3]).
% between(+N, +M, ?X): X is an integer, N =< X =< M. Capable of enumerating X.

% subterm(?Term, ?Sub, ?Sel): 
% Sub is subterm in Term at position Sel.
subterm(X, Sub, Sel) :- 
	Sub = X, Sel = [].
subterm(X, Sub, [I|Sel]) :-
        compound(X),                  % it is important that X is not a variable
	functor(X, _, Arity),         % because functor would raise an error
	between(1, Arity, I),
	arg(I, X, Y),
        subterm(Y, Sub, Sel).

