:- use_module(library(clpfd)).

% Uncomment this, when running in SWI:
% :- op(760, yfx, #<=>).
% P #<=> B :- P #<==> B.
% domain(L, Min, Max):- L ins Min..Max.


:- op(100, fy, a).    :- op(700, fy, not).   :- op(800, yfx, and).     
:- op(900, yfx, or).  :- op(950, xfy, says). 

holds(Stmt) :-                      % Statement Stmt is true.
    term_variables(Stmt, Vars), domain(Vars, 0, 1),
    % term_variables(+T, -Vs): Vs is the list of vars in term T 
    has_value(Stmt, 1), labeling([], Vars).

native(knave,  0).
native(knight, 1).

% has_value(Stmt, Val): The truth value of statement Stmt is Val.
has_value(X is a Native,
                     V) :- native(Native, N), V #<=> X #= N.
has_value(X says S,  V) :- has_value(S,  V0), V #<=> X #= V0.
has_value(S1 and S2, V) :- has_value(S1, V1),
                           has_value(S2, V2), V #<=> V1 #/\ V2.
has_value(S1 or S2,  V) :- has_value(S1, V1),            
                           has_value(S2, V2), V #<=> V1 #\/ V2.
has_value(not S1,    V) :- has_value(S1, V1), V #<=> #\ V1.

:- multifile portray/1. % the clauses of pred. portray/1 can be scattered
                        % over multiple files

portray(Term) :- native(Native, Term), write(Native).


