

test1(L) :-
	length(L, 3),
	domain(L, 1, 100),
	count(3, L, #=, C), 
	count(2, L, #>, C),
	C #> 0,
	labeling([], L).

test2(L) :-
	length(L,3),
	domain(L,1,100),
	global_cardinality(L,[2-_X,3-_Y]),
	_X#>_Y,
	_Y#>0,
	labeling([], L).

test3(L) :-
	length(L, 3), domain(L, 1, 3), nvalue(1, L), labeling([], L).

test4(Xs, Ps, Ys) :-
	Xs=[A,B], Ps=[_,_], Ys=[_,_], A in 5..6, B in {1,3},
	sorting(Xs, Ps, Ys).

test5(A, B, C, X, Y, Z) :-
	L=[A,B,C], M=[X,Y,Z], domain(L, 3, 7), domain(M, 2, 4), X #< 4, 
	lex_chain([L,M]).

test6(A,B,C) :-
	L=[A,B,C], domain(L,1,2), all_different(L).

test7(A,B,C) :-
	L=[A,B,C], domain(L,1,2), all_distinct(L).

test8(Xs, Ys) :-
	length(Xs, 3), assignment(Xs, Ys), Ys = [3|_], labeling([], Xs).

test9(Xs) :-
	length(Xs, 4), circuit(Xs), Xs = [2|_], labeling([], Xs).

test10(Start1,Start2,Start3,End1,End2,End3) :-
	domain([Start1,Start2,End1,End2],0,200),
	domain([Start3,End3],50,150),
	cumulative([task(Start1,100,End1,15,1),task(Start2,100,End2,10,2),task(Start3,50,End3,10,3)],[limit(20)]),
	labeling([],[Start1]).

test11(Y) :-
	relation(X, [0-(2..4),1-(3..4),2-{0,4},3-{0,1},4-(0..2)], Y),
	% relation abs(X-Y) > 1 on the interval 0..4
	X in {0,2}.

test12(X, Y, Z) :-
	table([[X,Y],[Y,Z]], [[1,3],[4,6],[3,5],[6,8]]).

test13(L) :-
	length(L,4),
	automaton(L,[source(s0),sink(s2)],[arc(s0,1,s1),arc(s1,1,s1),arc(s1,2,s2),arc(s2,2,s2)]),
    labeling([],L).

test14(A,B) :-
	case([X,Y],[[A,B]],[node(0,X,[(1..1)-1,(2..3)-2,(4..4)-1,(5..6)-2]),node(1,Y,[0..0]),node(2,Y,[1..1])]),
	labeling([],[A,B]),write(A-B),write(' '),fail.

test15(X, L, Y) :-
	L=[_A,B,_C], domain(L, 1, 5), B#<3, Y in 4..6, element(X, L, Y).

test16(X, L, Y) :-
	L = [A,B], A in 1..2, B in 5..7, element(X, L, Y).

