:- use_module(library(clpfd)).

'x=<y'(X,Y) +:
    X in inf..max(Y),        % intersect X with inf..max(Y)
    Y in min(X)..sup.        % intersect Y with min(X)..sup
'x=<y'(X,Y) -:		     
    X in (min(Y)+1)..sup,    
    Y in inf..(max(X)-1).    
'x=<y'(X,Y) +?               % X=<Y is entailed if the domain of X
    X in inf..min(Y).        % becomes a subset of  inf..min(Y)
'x=<y'(X,Y) -?               % Negation X > Y is entailed when X's 
    X in (max(Y)+1)..sup.    % domain is a subset of (max(Y)+1)..sup

end_of_file.

| ?- X in 2..4, Y in 1..3, 'x=<y'(X, Y).
X in 2..3,
Y in 2..3 ? ;
no
| ?- domain([X,Y], 1, 3), #\ 'x=<y'(X, Y).
X in 2..3,
Y in 1..2 ? ;
no
| ?- X in 2..4, Y in 1..3, 'x=<y'(X, Y) #<=> B.
X in 2..4,
Y in 1..3,
B in 0..1 ? ;
no
| ?- X in 2..3, Y in 2..3, 'x=<y'(X, Y) #<=> B.
X in 2..3,
Y in 2..3,
B in 0..1 ? 
yes
| ?- X in 2..3, Y in 3..5, 'x=<y'(X, Y) #<=> B.
B = 1,
X in 2..3,
Y in 3..5 ? ;
no
| ?- X in 6..sup, Y in 3..5, 'x=<y'(X, Y) #<=> B.
B = 0,
X in 6..sup,
Y in 3..5 ? ;
no
| ?- 
