:- use_module(library(clpfd)).

lseq(X, Y) :-
    fd_global(lseq(X,Y), void, [min(X),max(Y)]).
    %         ^^^^^^^^^                           constraint name
    %                    ^^^^                     initial state
    %                          ^^^^^^^^^^^^^^^    wake-up conditions

:- multifile clpfd:dispatch_global/4.
:- discontiguous clpfd:dispatch_global/4.
clpfd:dispatch_global(lseq(X,Y), St, St, Actions) :-
        dispatch_lseq(X, Y, Actions).

dispatch_lseq(X, Y, Actions) :-
    fd_min(X, MinX), fd_max(X, MaxX),  % get min of X in MinX, etc.
    fd_min(Y, MinY), fd_max(Y, MaxY),
    (   number(MaxX), number(MinY), MaxX =< MinY
    ->  Actions = [exit]
    ;   Actions = [X in inf..MaxY,Y in MinX..sup]
    ).

end_of_file.


| ?- assert(clpfd:full_answer).
yes
| ?- X in 2..4, Y in 1..3, lseq(X, Y).
user:lseq(X,Y),
X in 2..3,
Y in 2..3 ? ;
no
| ?- X in 2..4, Y in 0..1, lseq(X, Y).
no
| ?- X in 2..4, Y in 4..7, lseq(X, Y).
X in 2..4,
Y in 4..7 ? ;
no
| ?- X in 2..4, Y in 4..7, X #=< Y.
clpfd:(X#=<Y),
X in 2..4,
Y in 4..7 ? ;
no
| ?- X in 2..4, Y = 7, X #=< Y.
Y = 7,
X in 2..4 ? ;
no
| ?- 
