% Writes out text Txt and the time T, in milliseconds, needed to to
% either find the first solution of Goal or to fail the Goal,
% Kind is either runtime or walltime, specifying whether to use the
% CPU time or wall clock time, respectively.
time0(_Txt, Kind, Goal, _T) :-
	statistics(Kind, _), 
	(   call(Goal) -> fail
	;   fail
	).
time0(Txt, Kind, _, T) :-
    statistics(Kind, [_,T]),   % T is the (run/wall)time since the 
                               % previous invocation of statistics/2
	kind_msg(Kind, KindM),
	format('~w ~w time = ~3d sec\n', [Txt,KindM,T]).


kind_msg(runtime, 'CPU').
kind_msg(walltime, 'Real').

time0(Txt, Goal, T) :-
	time0(Txt, runtime, Goal, T).

time0(Txt, Goal) :-
	time0(Txt, runtime, Goal, _).

time0w(Txt, Goal) :-
	time0(Txt, walltime, Goal, _).



